


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/examples/ntlmrelayx/utils/ssl.py: 17%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/examples/ntlmrelayx/utils/ssl.py</b> :
            <span class="pc_cov">17%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            30 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">5 run</span>
            <span class="mis shortkey_m button_toggle_mis">25 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">0 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="pln"><a href="#n18">18</a></p>
<p id="n19" class="pln"><a href="#n19">19</a></p>
<p id="n20" class="pln"><a href="#n20">20</a></p>
<p id="n21" class="pln"><a href="#n21">21</a></p>
<p id="n22" class="stm run hide_run"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="pln"><a href="#n24">24</a></p>
<p id="n25" class="pln"><a href="#n25">25</a></p>
<p id="n26" class="pln"><a href="#n26">26</a></p>
<p id="n27" class="pln"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="pln"><a href="#n29">29</a></p>
<p id="n30" class="stm mis"><a href="#n30">30</a></p>
<p id="n31" class="stm mis"><a href="#n31">31</a></p>
<p id="n32" class="pln"><a href="#n32">32</a></p>
<p id="n33" class="pln"><a href="#n33">33</a></p>
<p id="n34" class="stm mis"><a href="#n34">34</a></p>
<p id="n35" class="stm mis"><a href="#n35">35</a></p>
<p id="n36" class="pln"><a href="#n36">36</a></p>
<p id="n37" class="stm mis"><a href="#n37">37</a></p>
<p id="n38" class="stm mis"><a href="#n38">38</a></p>
<p id="n39" class="stm mis"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="stm mis"><a href="#n41">41</a></p>
<p id="n42" class="pln"><a href="#n42">42</a></p>
<p id="n43" class="stm mis"><a href="#n43">43</a></p>
<p id="n44" class="stm mis"><a href="#n44">44</a></p>
<p id="n45" class="stm mis"><a href="#n45">45</a></p>
<p id="n46" class="stm mis"><a href="#n46">46</a></p>
<p id="n47" class="pln"><a href="#n47">47</a></p>
<p id="n48" class="pln"><a href="#n48">48</a></p>
<p id="n49" class="stm run hide_run"><a href="#n49">49</a></p>
<p id="n50" class="pln"><a href="#n50">50</a></p>
<p id="n51" class="stm run hide_run"><a href="#n51">51</a></p>
<p id="n52" class="pln"><a href="#n52">52</a></p>
<p id="n53" class="pln"><a href="#n53">53</a></p>
<p id="n54" class="pln"><a href="#n54">54</a></p>
<p id="n55" class="stm mis"><a href="#n55">55</a></p>
<p id="n56" class="stm mis"><a href="#n56">56</a></p>
<p id="n57" class="stm mis"><a href="#n57">57</a></p>
<p id="n58" class="stm mis"><a href="#n58">58</a></p>
<p id="n59" class="stm mis"><a href="#n59">59</a></p>
<p id="n60" class="stm mis"><a href="#n60">60</a></p>
<p id="n61" class="stm mis"><a href="#n61">61</a></p>
<p id="n62" class="stm mis"><a href="#n62">62</a></p>
<p id="n63" class="stm mis"><a href="#n63">63</a></p>
<p id="n64" class="pln"><a href="#n64">64</a></p>
<p id="n65" class="stm mis"><a href="#n65">65</a></p>
<p id="n66" class="stm mis"><a href="#n66">66</a></p>
<p id="n67" class="pln"><a href="#n67">67</a></p>
<p id="n68" class="pln"><a href="#n68">68</a></p>
<p id="n69" class="stm mis"><a href="#n69">69</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># SSL utilities</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># Author:</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#  Dirk-jan Mollema (@_dirkjan) / Fox-IT (https://www.fox-it.com)</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com">#     Various functions and classes for SSL support:</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com">#      - generating certificates</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com">#      - creating SSL capable SOCKS protocols</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="com"># Most of the SSL generation example code comes from the pyopenssl examples</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="pln"><span class="com">#    https://github.com/pyca/pyopenssl/blob/master/examples/certgen.py</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="pln"><span class="com"># Made available under the Apache license by the pyopenssl team</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="pln"><span class="com">#   See https://github.com/pyca/pyopenssl/blob/master/LICENSE</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="stm run hide_run"><span class="key">from</span> <span class="nam">OpenSSL</span> <span class="key">import</span> <span class="nam">crypto</span><span class="op">,</span> <span class="nam">SSL</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">LOG</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t25" class="pln"><span class="com"># This certificate is not supposed to be exposed on the network</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="pln"><span class="com"># but only used for the local SOCKS plugins</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="pln"><span class="com"># therefore, for now we don't bother with a CA and with hosts/hostnames matching</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run"><span class="key">def</span> <span class="nam">generateImpacketCert</span><span class="op">(</span><span class="nam">certname</span><span class="op">=</span><span class="str">'/tmp/impacket.crt'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="pln">    <span class="com"># Create a private key</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm mis">    <span class="nam">pkey</span> <span class="op">=</span> <span class="nam">crypto</span><span class="op">.</span><span class="nam">PKey</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm mis">    <span class="nam">pkey</span><span class="op">.</span><span class="nam">generate_key</span><span class="op">(</span><span class="nam">crypto</span><span class="op">.</span><span class="nam">TYPE_RSA</span><span class="op">,</span> <span class="num">2048</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t33" class="pln">    <span class="com"># Create the certificate</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm mis">    <span class="nam">cert</span> <span class="op">=</span> <span class="nam">crypto</span><span class="op">.</span><span class="nam">X509</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm mis">    <span class="nam">cert</span><span class="op">.</span><span class="nam">gmtime_adj_notBefore</span><span class="op">(</span><span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="pln">    <span class="com"># Valid for 5 years</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm mis">    <span class="nam">cert</span><span class="op">.</span><span class="nam">gmtime_adj_notAfter</span><span class="op">(</span><span class="num">60</span><span class="op">*</span><span class="num">60</span><span class="op">*</span><span class="num">24</span><span class="op">*</span><span class="num">365</span><span class="op">*</span><span class="num">5</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm mis">    <span class="nam">subj</span> <span class="op">=</span> <span class="nam">cert</span><span class="op">.</span><span class="nam">get_subject</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm mis">    <span class="nam">subj</span><span class="op">.</span><span class="nam">CN</span> <span class="op">=</span> <span class="str">'impacket'</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">    <span class="nam">cert</span><span class="op">.</span><span class="nam">set_pubkey</span><span class="op">(</span><span class="nam">pkey</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm mis">    <span class="nam">cert</span><span class="op">.</span><span class="nam">sign</span><span class="op">(</span><span class="nam">pkey</span><span class="op">,</span> <span class="str">"sha256"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="pln">    <span class="com"># We write both from the same file</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm mis">    <span class="key">with</span> <span class="nam">open</span><span class="op">(</span><span class="nam">certname</span><span class="op">,</span> <span class="str">'w'</span><span class="op">)</span> <span class="key">as</span> <span class="nam">certfile</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm mis">        <span class="nam">certfile</span><span class="op">.</span><span class="nam">write</span><span class="op">(</span><span class="nam">crypto</span><span class="op">.</span><span class="nam">dump_privatekey</span><span class="op">(</span><span class="nam">crypto</span><span class="op">.</span><span class="nam">FILETYPE_PEM</span><span class="op">,</span> <span class="nam">pkey</span><span class="op">)</span><span class="op">.</span><span class="nam">decode</span><span class="op">(</span><span class="str">'utf-8'</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm mis">        <span class="nam">certfile</span><span class="op">.</span><span class="nam">write</span><span class="op">(</span><span class="nam">crypto</span><span class="op">.</span><span class="nam">dump_certificate</span><span class="op">(</span><span class="nam">crypto</span><span class="op">.</span><span class="nam">FILETYPE_PEM</span><span class="op">,</span> <span class="nam">cert</span><span class="op">)</span><span class="op">.</span><span class="nam">decode</span><span class="op">(</span><span class="str">'utf-8'</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="stm mis">    <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">'Wrote certificate to %s'</span> <span class="op">%</span> <span class="nam">certname</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t48" class="pln"><span class="com"># Class to wrap the client socket in SSL when serving as a SOCKS server</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm run hide_run"><span class="key">class</span> <span class="nam">SSLServerMixin</span><span class="op">(</span><span class="nam">object</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="pln">    <span class="com"># This function will wrap the socksSocket in an SSL layer</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm run hide_run">    <span class="key">def</span> <span class="nam">wrapClientConnection</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">cert</span><span class="op">=</span><span class="str">'/tmp/impacket.crt'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="pln">        <span class="com"># Create a context, we don't really care about the SSL/TLS</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="pln">        <span class="com"># versions used since it is only intended for local use and thus</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="pln">        <span class="com"># doesn't have to be super-secure</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="stm mis">        <span class="nam">ctx</span> <span class="op">=</span> <span class="nam">SSL</span><span class="op">.</span><span class="nam">Context</span><span class="op">(</span><span class="nam">SSL</span><span class="op">.</span><span class="nam">SSLv23_METHOD</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="stm mis">            <span class="nam">ctx</span><span class="op">.</span><span class="nam">use_privatekey_file</span><span class="op">(</span><span class="nam">cert</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm mis">            <span class="nam">ctx</span><span class="op">.</span><span class="nam">use_certificate_file</span><span class="op">(</span><span class="nam">cert</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm mis">        <span class="key">except</span> <span class="nam">SSL</span><span class="op">.</span><span class="nam">Error</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'SSL requested - generating self-signed certificate in /tmp/impacket.crt'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="stm mis">            <span class="nam">generateImpacketCert</span><span class="op">(</span><span class="nam">cert</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="stm mis">            <span class="nam">ctx</span><span class="op">.</span><span class="nam">use_privatekey_file</span><span class="op">(</span><span class="nam">cert</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm mis">            <span class="nam">ctx</span><span class="op">.</span><span class="nam">use_certificate_file</span><span class="op">(</span><span class="nam">cert</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t65" class="stm mis">        <span class="nam">sslSocket</span> <span class="op">=</span> <span class="nam">SSL</span><span class="op">.</span><span class="nam">Connection</span><span class="op">(</span><span class="nam">ctx</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm mis">        <span class="nam">sslSocket</span><span class="op">.</span><span class="nam">set_accept_state</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t68" class="pln">        <span class="com"># Now set this property back to the SSL socket instead of the regular one</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">socksSocket</span> <span class="op">=</span> <span class="nam">sslSocket</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
